Skip to main content
POST
/
v2
/
commands
/
submit-and-wait
/v2/commands/submit-and-wait
curl --request POST \
  --url https://api.example.com/v2/commands/submit-and-wait \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "commands": [
    {
      "CreateAndExerciseCommand": {
        "templateId": "<string>",
        "createArguments": "<unknown>",
        "choice": "<string>",
        "choiceArgument": "<unknown>"
      }
    }
  ],
  "commandId": "<string>",
  "actAs": [
    "<string>"
  ],
  "userId": "<string>",
  "readAs": [
    "<string>"
  ],
  "workflowId": "<string>",
  "deduplicationPeriod": {
    "DeduplicationDuration": {
      "value": {
        "seconds": 123,
        "nanos": 123
      }
    }
  },
  "minLedgerTimeAbs": "<string>",
  "submissionId": "<string>",
  "disclosedContracts": [
    {
      "createdEventBlob": "<string>",
      "templateId": "<string>",
      "contractId": "<string>",
      "synchronizerId": "<string>"
    }
  ],
  "synchronizerId": "<string>",
  "packageIdSelectionPreference": [
    "<string>"
  ],
  "prefetchContractKeys": [
    {
      "templateId": "<string>",
      "contractKey": "<unknown>"
    }
  ],
  "tapsMaxPasses": 123
}
'
{
  "updateId": "<string>",
  "completionOffset": 123
}

Documentation Index

Fetch the complete documentation index at: https://docs.canton.network/llms.txt

Use this file to discover all available pages before exploring further.

Authorizations

Authorization
string
header
required

Ledger API standard JWT token

Body

application/json

A composite command that groups multiple commands together.

commands
Command · object[]
required

Individual elements of this atomic command. Must be non-empty.

Required: must be non-empty

A command can either create a new contract or exercise a choice on an existing contract.

commandId
string
required

Uniquely identifies the command. The triple (user_id, act_as, command_id) constitutes the change ID for the intended ledger change, where act_as is interpreted as a set of party names. The change ID can be used for matching the intended ledger changes with all their completions. Must be a valid LedgerString (as described in value.proto).

Required

actAs
string[]
required

Set of parties on whose behalf the command should be executed. If ledger API authorization is enabled, then the authorization metadata must authorize the sender of the request to act on behalf of each of the given parties. Each element must be a valid PartyIdString (as described in value.proto).

Required: must be non-empty

userId
string

Uniquely identifies the participant user that issued the command. Must be a valid UserIdString (as described in value.proto). Required unless authentication is used with a user token. In that case, the token's user-id will be used for the request's user_id.

Optional

readAs
string[]

Set of parties on whose behalf (in addition to all parties listed in act_as) contracts can be retrieved. This affects Daml operations such as fetch, fetchByKey, lookupByKey, exercise, and exerciseByKey. Note: A participant node of a Daml network can host multiple parties. Each contract present on the participant node is only visible to a subset of these parties. A command can only use contracts that are visible to at least one of the parties in act_as or read_as. This visibility check is independent from the Daml authorization rules for fetch operations. If ledger API authorization is enabled, then the authorization metadata must authorize the sender of the request to read contract data on behalf of each of the given parties.

Optional: can be empty

workflowId
string

Identifier of the on-ledger workflow that this command is a part of. Must be a valid LedgerString (as described in value.proto).

Optional

deduplicationPeriod
DeduplicationPeriod · object

Specifies the deduplication period for the change ID. If omitted, the participant will assume the configured maximum deduplication time.

Optional

minLedgerTimeAbs
string

Lower bound for the ledger time assigned to the resulting transaction. Note: The ledger time of a transaction is assigned as part of command interpretation. Use this property if you expect that command interpretation will take a considerate amount of time, such that by the time the resulting transaction is sequenced, its assigned ledger time is not valid anymore. Must not be set at the same time as min_ledger_time_rel.

Optional

minLedgerTimeRel
Duration · object

Same as min_ledger_time_abs, but specified as a duration, starting from the time the command is received by the server. Must not be set at the same time as min_ledger_time_abs.

Optional

submissionId
string

A unique identifier to distinguish completions for different submissions with the same change ID. Typically a random UUID. Applications are expected to use a different UUID for each retry of a submission with the same change ID. Must be a valid LedgerString (as described in value.proto).

If omitted, the participant or the committer may set a value of their choice.

Optional

disclosedContracts
DisclosedContract · object[]

Additional contracts used to resolve contract & contract key lookups.

Optional: can be empty

synchronizerId
string

Must be a valid synchronizer id

Optional

packageIdSelectionPreference
string[]

The package-id selection preference of the client for resolving package names and interface instances in command submission and interpretation

Optional: can be empty

prefetchContractKeys
PrefetchContractKey · object[]

Fetches the contract keys into the caches to speed up the command processing. Should only contain contract keys that are expected to be resolved during interpretation of the commands. Keys of disclosed contracts do not need prefetching.

Optional: can be empty

tapsMaxPasses
integer<int32>

The maximum number of passes for the Topology-Aware Package Selection (TAPS). Higher values can increase the chance of successful package selection for routing of interpreted transactions. If unset, this defaults to the value defined in the participant configuration. The provided value must not exceed the limit specified in the participant configuration.

Optional

Response

updateId
string
required

The id of the transaction that resulted from the submitted command. Must be a valid LedgerString (as described in value.proto).

Required

completionOffset
integer<int64>
required

The details of the offset field are described in community/ledger-api/README.md.

Required